package com.example.writetoadaptivefastchargeproperty;

import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;

import com.google.android.material.snackbar.Snackbar;

import androidx.appcompat.app.AppCompatActivity;

import android.provider.Settings;
import android.util.Log;
import android.view.View;

import androidx.navigation.NavController;
import androidx.navigation.Navigation;
import androidx.navigation.ui.AppBarConfiguration;
import androidx.navigation.ui.NavigationUI;

import com.example.writetoadaptivefastchargeproperty.databinding.ActivityMainBinding;

import android.view.Menu;
import android.view.MenuItem;
import android.widget.Button;

public class MainActivity extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        this.setContentView(R.layout.activity_main);

        final boolean settingsCanWrite = Settings.System.canWrite(this);
        if (!settingsCanWrite) {
            final Button writeButton = this.findViewById(R.id.write_settings_permission_button);
            writeButton.setOnClickListener((b) -> {
                final Intent intent = new Intent(Settings.ACTION_MANAGE_WRITE_SETTINGS);
                intent.setData(Uri.parse("package:" + this.getPackageName()));
                intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                this.startActivity(intent);
            });
        } else {

            final Button write0ToAdaptiveFastCharge = this.findViewById(R.id.write_0_to_adaptive_fast_charge);
            write0ToAdaptiveFastCharge.setOnClickListener((b) -> {
                this.writeToAdaptiveFastCharge(0, "write_0_to_adaptive_fast_charge done");
            });

            final Button write1ToAdaptiveFastCharge = this.findViewById(R.id.write_1_to_adaptive_fast_charge);
            write1ToAdaptiveFastCharge.setOnClickListener((b) -> {
                this.writeToAdaptiveFastCharge(1, "write_1_to_adaptive_fast_charge done");
            });
        }
    }

    @Override
    protected void onResume() {

        super.onResume();
        this.setContentView(R.layout.activity_main);

        final boolean settingsCanWrite = Settings.System.canWrite(this);
        if (!settingsCanWrite) {
            final Button writeButton = this.findViewById(R.id.write_settings_permission_button);
            writeButton.setOnClickListener((b) -> {
                final Intent intent = new Intent(Settings.ACTION_MANAGE_WRITE_SETTINGS);
                intent.setData(Uri.parse("package:" + this.getPackageName()));
                intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                this.startActivity(intent);
            });
            writeButton.setVisibility(View.VISIBLE);
        } else {

            final Button write0ToAdaptiveFastCharge = this.findViewById(R.id.write_0_to_adaptive_fast_charge);
            write0ToAdaptiveFastCharge.setOnClickListener((b) -> {
                this.writeToAdaptiveFastCharge(0, "write_0_to_adaptive_fast_charge done");
            });

            final Button write1ToAdaptiveFastCharge = this.findViewById(R.id.write_1_to_adaptive_fast_charge);
            write1ToAdaptiveFastCharge.setOnClickListener((b) -> {
                this.writeToAdaptiveFastCharge(1, "write_1_to_adaptive_fast_charge done");
            });
            write0ToAdaptiveFastCharge.setVisibility(View.VISIBLE);
            write1ToAdaptiveFastCharge.setVisibility(View.VISIBLE);
        }
    }

    private void writeToAdaptiveFastCharge(
            int value,
            String messageText
    ) {
        Settings.System.putInt(this.getContentResolver(), "adaptive_fast_charging", value);
        Log.i("MAIN", messageText);
    }

}